author | Junio C Hamano <junkio@cox.net> | |
Tue, 13 Feb 2007 21:48:52 +0000 (13:48 -0800) | ||
committer | Junio C Hamano <junkio@cox.net> | |
Tue, 13 Feb 2007 21:48:52 +0000 (13:48 -0800) |
* 'master' of git://repo.or.cz/git-gui:
git-gui: fix typo in GIT-VERSION-GEN, "/dev/null" not "/devnull"
git-gui: fix typo in GIT-VERSION-GEN, "/dev/null" not "/devnull"
1 | 2 | |||
---|---|---|---|---|
git-gui/GIT-VERSION-GEN | patch | | diff1 | | | | blob | history |
diff --cc git-gui/GIT-VERSION-GEN
index 8fac8cb410b6d4e3e10ed775a5c179698b49571e,0000000000000000000000000000000000000000..9966126da2682f7b7d65b71a3225dddd1b5fe55b
mode 100755,000000..100755
mode 100755,000000..100755
--- /dev/null
+++ b/git-gui/GIT-VERSION-GEN
- for p in $(git rev-list --parents --max-count=1 $head 2>/devnull)
+#!/bin/sh
+
+GVF=GIT-VERSION-FILE
+DEF_VER=0.6.GITGUI
+
+LF='
+'
+
+tree_search ()
+{
+ head=$1
+ tree=$2
++ for p in $(git rev-list --parents --max-count=1 $head 2>/dev/null)
+ do
+ test $tree = $(git rev-parse $p^{tree} 2>/dev/null) &&
+ vn=$(git describe --abbrev=4 $p 2>/dev/null) &&
+ case "$vn" in
+ gitgui-[0-9]*) echo $vn; break;;
+ esac
+ done
+}
+
+# We may be a subproject, so try looking for the merge
+# commit that supplied this directory content if we are
+# not at the toplevel. We probably will always be the
+# second parent in the commit, but we shouldn't rely on
+# that fact.
+#
+# If we are at the toplevel or the merge assumption fails
+# try looking for a gitgui-* tag, or fallback onto the
+# distributed version file.
+
+if prefix="$(git rev-parse --show-prefix 2>/dev/null)"
+ test -n "$prefix" &&
+ head=$(git rev-list --max-count=1 HEAD -- . 2>/dev/null) &&
+ tree=$(git rev-parse --verify "HEAD:$prefix" 2>/dev/null) &&
+ VN=$(tree_search $head $tree)
+ case "$VN" in
+ gitgui-[0-9]*) : happy ;;
+ *) (exit 1) ;;
+ esac
+then
+ VN=$(echo "$VN" | sed -e 's/^gitgui-//;s/-/./g');
+elif VN=$(git describe --abbrev=4 HEAD 2>/dev/null) &&
+ case "$VN" in
+ gitgui-[0-9]*) : happy ;;
+ *) (exit 1) ;;
+ esac
+then
+ VN=$(echo "$VN" | sed -e 's/^gitgui-//;s/-/./g');
+elif test -f version
+then
+ VN=$(cat version) || VN="$DEF_VER"
+else
+ VN="$DEF_VER"
+fi
+
+dirty=$(sh -c 'git diff-index --name-only HEAD' 2>/dev/null) || dirty=
+case "$dirty" in
+'')
+ ;;
+*)
+ VN="$VN-dirty" ;;
+esac
+
+if test -r $GVF
+then
+ VC=$(sed -e 's/^GITGUI_VERSION = //' <$GVF)
+else
+ VC=unset
+fi
+test "$VN" = "$VC" || {
+ echo >&2 "GITGUI_VERSION = $VN"
+ echo "GITGUI_VERSION = $VN" >$GVF
+}
+
+